# RE-TM245P
The end goal of this project is to convert a partially broken TM245P Pick and Place to OpenPNP
while replacing as little hardware as possible. The difficulty in this is that the feeders and
everything on the head are CAN bus controlled. In an effort to not replace these parts, the
protocol will need to be reverse engineered.

# Approaches

### Smoothieware Port

The Charmhigh conversion undertaken by others approaches leaving the controller largely intact
and flashing a Smoothieware port onto the STM32. The repo notes suggest the Charmhigh used an
STM32F4, which the TM245P also uses. Specifcally the STM32F407ZGT6.

https://github.com/mattthebaker/Smoothieware-CHMT

### 'Decap'
In this approach the entire head unit will be bypassed. Ideally this could be accomplished by
utilizing the existing IDC connector on the power/comm sub-board.

# 'CAN Bus'
Communication is done over the VP230 CAN Transceiver, though it doesn't look to be real CAN.
Instead the STM32 USART1 is connected so it's doing Syncronous UART over CAN. So it's really
just using the VP230 for differential signaling.

# Reading

https://www.eevblog.com/forum/manufacture/neoden-tm245p-teardown-and-upgrade/
